org.icefaces.ace.component.tableconfigpanel

## Class TableConfigPanelBase

- java.lang.Object
- - javax.faces.component.UIComponent
  - - javax.faces.component.UIComponentBase
    - - org.icefaces.ace.component.tableconfigpanel.TableConfigPanelBase

- All Implemented Interfaces:
    java.util.EventListener, javax.faces.component.behavior.ClientBehaviorHolder, javax.faces.component.PartialStateHolder, javax.faces.component.StateHolder, javax.faces.component.TransientStateHolder, javax.faces.event.ComponentSystemEventListener, javax.faces.event.FacesListener, javax.faces.event.SystemEventListenerHolder, IceClientBehaviorHolder, ITableConfigPanel
  Direct Known Subclasses:
    TableConfigPanel

      public abstract class TableConfigPanelBase
      extends javax.faces.component.UIComponentBase
      implements ITableConfigPanel, IceClientBehaviorHolder

  Renders a hidden panel with controls to configure column features. The table whose columns are to be configured is targeted with the 'for' attribute. The location of the button to reveal this panel is configured via the 'type' attribute.

  The table config panel renders three buttons, a checkmark which submits changes, a crossout that closes without submitting changes, and a trashcan, that closes and resets the column properties configurable via the table config panel to an unconfigured state.

  For more information, see the TableConfigPanel Wiki Documentation.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected static class` | `TableConfigPanelBase.PropertyKeys`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `COMPONENT_TYPE`
    `static java.lang.String` | `RENDERER_TYPE`

    - ### Fields inherited from class javax.faces.component.UIComponent

      `ATTRS_WITH_DECLARED_DEFAULT_VALUES, BEANINFO_KEY, bindings, COMPOSITE_COMPONENT_TYPE_KEY, COMPOSITE_FACET_NAME, CURRENT_COMPONENT, CURRENT_COMPOSITE_COMPONENT, FACETS_KEY, HONOR_CURRENT_COMPONENT_ATTRIBUTES_PARAM_NAME, VIEW_LOCATION_KEY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TableConfigPanelBase()`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addClientBehavior(java.lang.String eventName, javax.faces.component.behavior.ClientBehavior behavior)`
    `java.lang.String` | `getAccesskey()` Return the value of the `accesskey` property.
    `java.lang.String` | `getDefaultEventName()`
    `java.lang.String` | `getDefaultExecute(java.lang.String event)`
    `java.lang.String` | `getDefaultRender(java.lang.String event)`
    `java.lang.String` | `getDragHandle()` Return the value of the `dragHandle` property.
    `java.util.Collection<java.lang.String>` | `getEventNames()`
    `java.lang.String` | `getFamily()`
    `java.lang.String` | `getFor()` Return the value of the `for` property.
    `java.lang.Integer` | `getForcedRenderCount()` Return the value of the `forcedRenderCount` property.
    `java.lang.String` | `getInColumnId()` Return the value of the `inColumnId` property.
    `java.lang.String` | `getListenerArgument(java.lang.String event)`
    `java.lang.Integer` | `getOffsetLeft()` Return the value of the `offsetLeft` property.
    `java.lang.Integer` | `getOffsetTop()` Return the value of the `offsetTop` property.
    `java.lang.String` | `getType()` Return the value of the `type` property.
    `boolean` | `isColumnNameConfigurable()` Return the value of the `columnNameConfigurable` property.
    `boolean` | `isColumnOrderingConfigurable()` Return the value of the `columnOrderingConfigurable` property.
    `boolean` | `isColumnSortingConfigurable()` Return the value of the `columnSortingConfigurable` property.
    `boolean` | `isColumnVisibilityConfigurable()` Return the value of the `columnVisibilityConfigurable` property.
    `boolean` | `isHideDisabledRows()` Return the value of the `hideDisabledRows` property.
    `java.lang.Boolean` | `isModal()` Return the value of the `modal` property.
    `protected boolean` | `isPropertySet(java.lang.String finder)`
    `void` | `setAccesskey(java.lang.String accesskey)` Set the value of the `accesskey` property.
    `void` | `setColumnNameConfigurable(boolean columnNameConfigurable)` Set the value of the `columnNameConfigurable` property.
    `void` | `setColumnOrderingConfigurable(boolean columnOrderingConfigurable)` Set the value of the `columnOrderingConfigurable` property.
    `void` | `setColumnSortingConfigurable(boolean columnSortingConfigurable)` Set the value of the `columnSortingConfigurable` property.
    `void` | `setColumnVisibilityConfigurable(boolean columnVisibilityConfigurable)` Set the value of the `columnVisibilityConfigurable` property.
    `void` | `setDragHandle(java.lang.String dragHandle)` Set the value of the `dragHandle` property.
    `void` | `setFor(java.lang.String forTarget)` Set the value of the `for` property.
    `void` | `setForcedRenderCount(java.lang.Integer forcedRenderCount)` Set the value of the `forcedRenderCount` property.
    `void` | `setHideDisabledRows(boolean hideDisabledRows)` Set the value of the `hideDisabledRows` property.
    `void` | `setInColumnId(java.lang.String inColumnId)` Set the value of the `inColumnId` property.
    `void` | `setModal(java.lang.Boolean modal)` Set the value of the `modal` property.
    `void` | `setOffsetLeft(java.lang.Integer offsetLeft)` Set the value of the `offsetLeft` property.
    `void` | `setOffsetTop(java.lang.Integer offsetTop)` Set the value of the `offsetTop` property.
    `void` | `setType(java.lang.String type)` Set the value of the `type` property.
    `void` | `setValueExpression(java.lang.String name, javax.el.ValueExpression binding)`

    - ### Methods inherited from class javax.faces.component.UIComponentBase

      `addFacesListener, broadcast, clearInitialState, decode, encodeBegin, encodeChildren, encodeEnd, findComponent, getAttributes, getChildCount, getChildren, getClientBehaviors, getClientId, getFacesContext, getFacesListeners, getFacet, getFacetCount, getFacets, getFacetsAndChildren, getId, getListenersForEventClass, getParent, getRenderer, getRendererType, getRendersChildren, getValueBinding, invokeOnComponent, isRendered, isTransient, markInitialState, processDecodes, processRestoreState, processSaveState, processUpdates, processValidators, queueEvent, removeFacesListener, restoreAttachedState, restoreState, saveAttachedState, saveState, setId, setParent, setRendered, setRendererType, setTransient, setValueBinding, subscribeToEvent, unsubscribeFromEvent`

    - ### Methods inherited from class javax.faces.component.UIComponent

      `encodeAll, getClientId, getCompositeComponentParent, getContainerClientId, getCurrentComponent, getCurrentCompositeComponent, getNamingContainer, getResourceBundleMap, getStateHelper, getStateHelper, getTransientStateHelper, getTransientStateHelper, getValueExpression, initialStateMarked, isCompositeComponent, isInView, isVisitable, popComponentFromEL, processEvent, pushComponentToEL, restoreTransientState, saveTransientState, setInView, visitTree`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface javax.faces.component.behavior.ClientBehaviorHolder

      `getClientBehaviors`

- - ### Field Detail

    - #### COMPONENT_TYPE

          public static final java.lang.String COMPONENT_TYPE

      See Also:
        Constant Field Values

    - #### RENDERER_TYPE

          public static final java.lang.String RENDERER_TYPE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TableConfigPanelBase

          public TableConfigPanelBase()

  - ### Method Detail

    - #### getFamily

          public java.lang.String getFamily()

      Specified by:
        `getFamily` in class `javax.faces.component.UIComponent`

    - #### setAccesskey

          public void setAccesskey(java.lang.String accesskey)

      Set the value of the `accesskey` property.

      Contents: Access key that, when pressed, activates this component.

      Specified by:
        `setAccesskey` in interface `ITableConfigPanel`

    - #### getAccesskey

          public java.lang.String getAccesskey()

      Return the value of the `accesskey` property.

      Contents: Access key that, when pressed, activates this component.

      Specified by:
        `getAccesskey` in interface `ITableConfigPanel`

    - #### setColumnNameConfigurable

          public void setColumnNameConfigurable(boolean columnNameConfigurable)

      Set the value of the `columnNameConfigurable` property.

      Contents: Enable the configuration of column headerText properties.

      Specified by:
        `setColumnNameConfigurable` in interface `ITableConfigPanel`

    - #### isColumnNameConfigurable

          public boolean isColumnNameConfigurable()

      Return the value of the `columnNameConfigurable` property.

      Contents: Enable the configuration of column headerText properties.

      Specified by:
        `isColumnNameConfigurable` in interface `ITableConfigPanel`

    - #### setColumnOrderingConfigurable

          public void setColumnOrderingConfigurable(boolean columnOrderingConfigurable)

      Set the value of the `columnOrderingConfigurable` property.

      Contents: Enable the configuration of column order.

      Specified by:
        `setColumnOrderingConfigurable` in interface `ITableConfigPanel`

    - #### isColumnOrderingConfigurable

          public boolean isColumnOrderingConfigurable()

      Return the value of the `columnOrderingConfigurable` property.

      Contents: Enable the configuration of column order.

      Specified by:
        `isColumnOrderingConfigurable` in interface `ITableConfigPanel`

    - #### setColumnSortingConfigurable

          public void setColumnSortingConfigurable(boolean columnSortingConfigurable)

      Set the value of the `columnSortingConfigurable` property.

      Contents: Enable the configuration of column sorting priority and directions.

      Specified by:
        `setColumnSortingConfigurable` in interface `ITableConfigPanel`

    - #### isColumnSortingConfigurable

          public boolean isColumnSortingConfigurable()

      Return the value of the `columnSortingConfigurable` property.

      Contents: Enable the configuration of column sorting priority and directions.

      Specified by:
        `isColumnSortingConfigurable` in interface `ITableConfigPanel`

    - #### setColumnVisibilityConfigurable

          public void setColumnVisibilityConfigurable(boolean columnVisibilityConfigurable)

      Set the value of the `columnVisibilityConfigurable` property.

      Contents: Enable the configuration of column visibility.

      Specified by:
        `setColumnVisibilityConfigurable` in interface `ITableConfigPanel`

    - #### isColumnVisibilityConfigurable

          public boolean isColumnVisibilityConfigurable()

      Return the value of the `columnVisibilityConfigurable` property.

      Contents: Enable the configuration of column visibility.

      Specified by:
        `isColumnVisibilityConfigurable` in interface `ITableConfigPanel`

    - #### setDragHandle

          public void setDragHandle(java.lang.String dragHandle)

      Set the value of the `dragHandle` property.

      Contents: Defines a CSS selector of a TableConfigPanel subregion used as the handle when dragging the panel.

      Specified by:
        `setDragHandle` in interface `ITableConfigPanel`

    - #### getDragHandle

          public java.lang.String getDragHandle()

      Return the value of the `dragHandle` property.

      Contents: Defines a CSS selector of a TableConfigPanel subregion used as the handle when dragging the panel.

      Specified by:
        `getDragHandle` in interface `ITableConfigPanel`

    - #### setFor

          public void setFor(java.lang.String forTarget)

      Set the value of the `for` property.

      Contents: Defines the component ID of the DataTable this ConfigPanel manipulates.

      Specified by:
        `setFor` in interface `ITableConfigPanel`

    - #### getFor

          public java.lang.String getFor()

      Return the value of the `for` property.

      Contents: Defines the component ID of the DataTable this ConfigPanel manipulates.

      Specified by:
        `getFor` in interface `ITableConfigPanel`

    - #### setHideDisabledRows

          public void setHideDisabledRows(boolean hideDisabledRows)

      Set the value of the `hideDisabledRows` property.

      Contents: Enable to hide columns with configurable property set to false, rather than render them with a disabled style.

      Specified by:
        `setHideDisabledRows` in interface `ITableConfigPanel`

    - #### isHideDisabledRows

          public boolean isHideDisabledRows()

      Return the value of the `hideDisabledRows` property.

      Contents: Enable to hide columns with configurable property set to false, rather than render them with a disabled style. Default = 'false'.

      Specified by:
        `isHideDisabledRows` in interface `ITableConfigPanel`

    - #### setInColumnId

          public void setInColumnId(java.lang.String inColumnId)

      Set the value of the `inColumnId` property.

      Contents: Defines the column to render the 'launch' panel button in when using the 'in-col-left' or 'in-col-right' type options.

      Specified by:
        `setInColumnId` in interface `ITableConfigPanel`

    - #### getInColumnId

          public java.lang.String getInColumnId()

      Return the value of the `inColumnId` property.

      Contents: Defines the column to render the 'launch' panel button in when using the 'in-col-left' or 'in-col-right' type options.

      Specified by:
        `getInColumnId` in interface `ITableConfigPanel`

    - #### setModal

          public void setModal(java.lang.Boolean modal)

      Set the value of the `modal` property.

      Contents: Specify whether viewing this panel disables the rest of the application from input.

      Specified by:
        `setModal` in interface `ITableConfigPanel`

    - #### isModal

          public java.lang.Boolean isModal()

      Return the value of the `modal` property.

      Contents: Specify whether viewing this panel disables the rest of the application from input. Default = 'false'.

      Specified by:
        `isModal` in interface `ITableConfigPanel`

    - #### setOffsetLeft

          public void setOffsetLeft(java.lang.Integer offsetLeft)

      Set the value of the `offsetLeft` property.

      Contents: Define the distance in pixels from left boundary of the CSS positioning bounding parent. If undefined, the panel is positioned offset slightly from the target DataTable.

      Specified by:
        `setOffsetLeft` in interface `ITableConfigPanel`

    - #### getOffsetLeft

          public java.lang.Integer getOffsetLeft()

      Return the value of the `offsetLeft` property.

      Contents: Define the distance in pixels from left boundary of the CSS positioning bounding parent. If undefined, the panel is positioned offset slightly from the target DataTable.

      Specified by:
        `getOffsetLeft` in interface `ITableConfigPanel`

    - #### setOffsetTop

          public void setOffsetTop(java.lang.Integer offsetTop)

      Set the value of the `offsetTop` property.

      Contents: Define the distance in pixels from top boundary of the CSS positioning bounding parent. If undefined, the panel is positioned offset slightly from the target DataTable.

      Specified by:
        `setOffsetTop` in interface `ITableConfigPanel`

    - #### getOffsetTop

          public java.lang.Integer getOffsetTop()

      Return the value of the `offsetTop` property.

      Contents: Define the distance in pixels from top boundary of the CSS positioning bounding parent. If undefined, the panel is positioned offset slightly from the target DataTable.

      Specified by:
        `getOffsetTop` in interface `ITableConfigPanel`

    - #### setType

          public void setType(java.lang.String type)

      Set the value of the `type` property.

      Contents: Defines the display mode for the 'open' control panel button. Available options: first-col, last-col, in-col-right, in-col-left

      Specified by:
        `setType` in interface `ITableConfigPanel`

    - #### getType

          public java.lang.String getType()

      Return the value of the `type` property.

      Contents: Defines the display mode for the 'open' control panel button. Available options: first-col, last-col, in-col-right, in-col-left Default = 'first-col'.

      Specified by:
        `getType` in interface `ITableConfigPanel`

    - #### setForcedRenderCount

          public void setForcedRenderCount(java.lang.Integer forcedRenderCount)

      Set the value of the `forcedRenderCount` property.

      Specified by:
        `setForcedRenderCount` in interface `ITableConfigPanel`

    - #### getForcedRenderCount

          public java.lang.Integer getForcedRenderCount()

      Return the value of the `forcedRenderCount` property.

      Specified by:
        `getForcedRenderCount` in interface `ITableConfigPanel`

    - #### isPropertySet

          protected boolean isPropertySet(java.lang.String finder)

    - #### setValueExpression

          public void setValueExpression(java.lang.String name,
                                         javax.el.ValueExpression binding)

      Overrides:
        `setValueExpression` in class `javax.faces.component.UIComponent`

    - #### getEventNames

          public java.util.Collection<java.lang.String> getEventNames()

      Specified by:
        `getEventNames` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getEventNames` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultEventName

          public java.lang.String getDefaultEventName()

      Specified by:
        `getDefaultEventName` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `getDefaultEventName` in class `javax.faces.component.UIComponentBase`

    - #### getDefaultRender

          public java.lang.String getDefaultRender(java.lang.String event)

      Specified by:
        `getDefaultRender` in interface `IceClientBehaviorHolder`

    - #### getDefaultExecute

          public java.lang.String getDefaultExecute(java.lang.String event)

      Specified by:
        `getDefaultExecute` in interface `IceClientBehaviorHolder`

    - #### getListenerArgument

          public java.lang.String getListenerArgument(java.lang.String event)

      Specified by:
        `getListenerArgument` in interface `IceClientBehaviorHolder`

    - #### addClientBehavior

          public void addClientBehavior(java.lang.String eventName,
                                        javax.faces.component.behavior.ClientBehavior behavior)

      Specified by:
        `addClientBehavior` in interface `javax.faces.component.behavior.ClientBehaviorHolder`
      Overrides:
        `addClientBehavior` in class `javax.faces.component.UIComponentBase`

Copyright 2025 ICEsoft Technologies Canada, Corp. All Rights Reserved.